/**
 *  UOC Hive Campus per UOC OPEN API
 *  <br />
 *  
 *
 *  @author Ral Martnez Daz
 *  @version 1.0
 */
package com.uoc.hive.campus;

import net.smartam.leeloo.client.OAuthClient;
import net.smartam.leeloo.client.URLConnectionClient;
import net.smartam.leeloo.client.request.OAuthClientRequest;
import net.smartam.leeloo.client.response.OAuthJSONAccessTokenResponse;
import net.smartam.leeloo.common.exception.OAuthProblemException;
import net.smartam.leeloo.common.exception.OAuthSystemException;
import net.smartam.leeloo.common.message.types.GrantType;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.util.Log;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Toast;

public abstract class LoginActivity extends Activity {
	private String oauthToken;
	private static SharedPreferences settings;
	private ProgressDialog pd;
	public boolean running;
	
	private WebView mWebView;
	
	public abstract void NextActivityIntent(String ouathtoken);

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Log.i("LOGIN", "1");
		pd = new ProgressDialog(this);
		pd.setCancelable(false);
		pd.setIndeterminate(true);
		pd.setTitle("Carregant");
		pd.setMessage("validant l'usuari.");

	}

    
    protected static String getToken() {
		return settings.getString("oauthToken", "");
	}
	
	private String retriveAccesToken(String client, String secret,
			String redirectUri, String code) {
		OAuthClientRequest request = null;

		try {
			request = OAuthClientRequest
					.tokenLocation(Constants.ACCES_TOKEN_URI)
					.setGrantType(GrantType.AUTHORIZATION_CODE)
					.setClientId(client).setClientSecret(secret)
					.setRedirectURI(redirectUri).setCode(code)
					.buildBodyMessage();
		} catch (OAuthSystemException e) {
			Log.e("LOGIN_ERROR", "Se ha producido un error del sistema");
			e.printStackTrace();
			return null;
		}

		try {
			OAuthClient oAuthClient = new OAuthClient(new URLConnectionClient());
			OAuthJSONAccessTokenResponse response;
			response = oAuthClient.accessToken(request);
			oauthToken = response.getAccessToken();
			Log.v("LOGIN", response.getBody().toString());
			return oauthToken;

		} catch (OAuthSystemException e1) {
			Log.e("LOGIN_ERROR", "Ha habido un error en accesToken System");
			e1.printStackTrace();
			return null;
		} catch (OAuthProblemException e1) {
			Log.e("LOGIN_ERROR", "Ha habido un error en accesToken Problem");
			e1.printStackTrace();
			return null;
		}
	}

	protected String getToken(String client, String secret, String redirectUri,
			String code) {

		Log.i("LOGIN", "Getting oauthToken");

		oauthToken = retriveAccesToken(client, secret, redirectUri, code);
		return oauthToken;
	}


	

	public void IniciarLogin() {
		String str;
		
		
		mWebView = (WebView) findViewById(R.id.webLogon);
		
		// Activem JavaScript
		mWebView.getSettings().setJavaScriptEnabled(true);
		
		// Generem un WebView personalitzat per la validaci OOAuth 2.0 al Campus Virtual
		mWebView.setWebViewClient(new WebViewClient() {
			
			@Override 
			public boolean shouldOverrideUrlLoading (WebView webView, String url)
			{
				if (url != null && url.toString().startsWith(Constants.REDIRECT_URI)) {
					
					Uri uri = Uri.parse(url);					
					String code = uri.getQueryParameter("code");
					Log.i("LOGIN", "codi: " + code);
					
					new getTokenTask().execute(code);
					if (running) pd.show();
					// token = getToken(Constants.CLIENT, Constants.SECRET,
					// Constants.REDIRECT_URI, code);
					Log.i("LOGIN", "token: " + oauthToken);
					return true;
				}
				return false;
			}
		});
				
		OAuthClientRequest request = null;
		try {

			// preparamos la peticin con nuestro code
			request = OAuthClientRequest
					.authorizationLocation(Constants.AUTHORIZE_URI)
					// No se pasa como parametro, porque deberia ser siempre la
					// misma
					.setClientId(Constants.CLIENT)
					.setRedirectURI(Constants.REDIRECT_URI).buildQueryMessage();
		} catch (OAuthSystemException e) {
			e.printStackTrace();
		}
		
		str = Uri.parse(request.getLocationUri() + "&response_type=code").toString();		
		
		// Accedim a Campus Virtual per validaci
		mWebView.loadUrl(str);
	}

	private class getTokenTask extends AsyncTask<String, Void, String> {
		/*
		 * Get Token && start next activity
		 */
		@Override
		protected void onPreExecute() {
			running = true;
			super.onPreExecute();
		}

		protected void onPostExecute(String result) {
			oauthToken = result;
			running = false;
			pd.dismiss();
			if (oauthToken == null) {
				Toast.makeText(getApplicationContext(), "Error al hacer Login",
						Toast.LENGTH_LONG).show();
			} else {
				settings = getSharedPreferences(Constants.CONFIG_FILE,
						MODE_PRIVATE);
				settings.edit().putString("oauthToken", oauthToken).commit();
				
				// Estem logats.				
				NextActivityIntent(oauthToken);				
			}
			Log.v("ASYNC", "Token obtenido en asyncTask: " + result);
		}

		@Override
		protected String doInBackground(String... code) {
			return getToken(Constants.CLIENT, Constants.SECRET,
					Constants.REDIRECT_URI, code[0]);

		}
	}


    
}
