/**
 *  UOC Hive Campus per UOC OPEN API
 *  <br />
 *  
 *
 *  @author Ral Martnez Daz
 *  @version 1.0
 */

package com.uoc.hive.campus;



import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import android.util.Log;

/**
 * @author Ral Martnez Daz
 *
 */

//TODO: Implementar mtodes PUT, POST
public class RESTClientConnection {

	
	
	/**
	 * Donada l'adrea URI d'un recurs i el token d'identificaci de l'usuari,
	 * recupera la representaci JSON del recurs.
	 * 
	 * @param URI	Cont l'adrea de la consulta.
	 * @param token	Cont el token de l'usuari.
	 * @return retorna una cadena amb la resposta JSON a la consulta.
	 */
	public static String Get(String URI, String token) {
		
		HttpClient httpClient = new DefaultHttpClient();
		
		try {
			
			HttpGet httpGet = new HttpGet(URI+"?access_token="+token);
			httpGet.setHeader("content-type", "application/json");
			
			HttpResponse response = httpClient.execute(httpGet);			
			if (response.getStatusLine().getStatusCode() == HttpStatus.SC_UNAUTHORIZED) {
				
				// La crida HTTP retorna un codi d'estat 401, No autoritzat. 
				// Probablement falta la authoritzaci o el token OAuth ha caducat (proveu a fer un refresh)
				throw new ClientProtocolException("Falta la authoritzaci o el token OAuth ha caducat! ");
				
				// TO DO: Token caducat o erroni, tornar a presentar finestra de validaci
				
			} else if (response.getStatusLine().getStatusCode() == HttpStatus.SC_OK) {
				// La crida HTTP retorna un codi d'estat 200, s'ha completat correctament.
				// Retorna la resposta JSON de la crida.
				return EntityUtils.toString(response.getEntity());
				
			} else {
				// La crida no s'ha completat correctament. Mostra codi d'estat de la crida.
				throw new ClientProtocolException("HttpStatus code:" + response.getStatusLine().getStatusCode());
			}
			
		} catch (ClientProtocolException ex) {
			Log.e("REST", "GET Error! ", ex);
			
		} catch (Exception ex) {
			Log.e("REST", "GET error2! ", ex);
				
		} finally {
				// When HttpClient instance is no longer needed,
				// shut down the connection manager to ensure
				// immediate deallocation of all system resources
				httpClient.getConnectionManager().shutdown();
		}
		return null;
	
    }
}
