/**
 *  UOC Hive Campus per UOC OPEN API
 *  <br />
 *  
 *
 *  @author Ral Martnez Daz
 *  @version 1.0
 */

package com.uoc.hive.campus;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import com.google.gson.Gson;


public class Utilities {
		
		
		public static String getToken() {			
			return LoginActivity.getToken();
		}
		
		
		public static String toJSON(Object obj) {
			return new Gson().toJson(obj);
		}
		
		
		/**
	     * Retalla una cadena a una mida concreta        
		 * 
		 * @param String str -  una cadena que cont la data. 
		 * @param Int size - tamany de la cadena resultant.
		 * @return la cadena resultant.
		 */
		public static String cutString(int size, String str) {
			String tmp;
			tmp = str;
			if (tmp.length() > size) {
				tmp = str.substring(0, size) + "...";
			}
			
			return tmp;
					
		}
		
		/**
	    * Coverteix una String en un objecte Date        
		* 
		* @param String una cadena que cont la data. 
		* @return Un objecte Date amb la data.
		*/
		public static Date parseDateTime(String dateString) {
		    if (dateString == null) return null;
		    DateFormat fmt = new SimpleDateFormat("EEE MMM d HH:mm:ss Z yyyy",Locale.ENGLISH);		    
		    try {
		        return fmt.parse(dateString);
		    }
		    catch (ParseException e) {		       
		        return null;
		    }
		}
		
		/**
		* Coverteix una String Color en un Integer        
		* 
		* @param String una cadena que cont el color en format hexadecimal 
		* @return Un objecte Integer amb el valor del color.
		*/
		public static int parseColor (String color) {
			 return Integer.parseInt(color.replaceFirst("#",""),16);
			    
		}
		

	}

