/**
 *  UOC Hive Campus per UOC OPEN API
 *  <br />
 *  
 *
 *  @author Ral Martnez Daz
 *  @version 1.0
 */

package com.uoc.hive.campus;


import java.util.ArrayList;

import com.uoc.hive.campus.model.Board;
import com.uoc.hive.campus.model.BoardList;

import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;


public class listBoardAdapter extends BaseAdapter {
	
	private ArrayList<Board> boards;
	private Activity activity;
	private static LayoutInflater inflater=null;
	
	// Quantitat de caracters que es mostraran.	
	private static int titleSize = 20;
		

	/**
	 *  
	 */
	public listBoardAdapter(Activity a,BoardList m) {
		this.activity = a;
		this.boards = m.getBoardList();
		inflater = (LayoutInflater)activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		
	}

	@Override
	public int getCount() {
		return boards.size();
	}

	@Override
	public Object getItem(int position) {
		return position;
	}

	@Override
	public long getItemId(int position) {		
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		 	String str;			 	
			View vi=convertView;
			long unreadMessages = 0;
			long totalMessages = 0;
						 
	        if(convertView==null)
	        	vi = inflater.inflate(R.layout.list_board_row, null);
	 
	        TextView name = (TextView)vi.findViewById(R.id.boardName); 	// nom del recurs       
	        TextView messagePendent = (TextView)vi.findViewById(R.id.aula_messagePendent); 	
	        TextView messageTotal = (TextView)vi.findViewById(R.id.aula_messageTotal); 	
	        
	        Board board = boards.get(position);
	        
	        // Recuperem els missatges sense llegir
	        unreadMessages = board.getUnreadMessages();
	        if (unreadMessages > 0){
	        	messagePendent.setText(Long.toString(unreadMessages));
	        } else {
	        	messagePendent.setText("0");
	        }
	        
	        // Recuperem el total del missatge
	        totalMessages = board.getTotalMessages();
	        if (totalMessages > 0){
	        	messageTotal.setText(Long.toString(totalMessages));
	        } else {
	        	messageTotal.setText("0");	        	
	        }
	       	 
	        // Recuperem el nom del recurs
	        str =  board.getTitle();
	        if (str.length() > titleSize) {
	    	    str = Utilities.cutString(titleSize,str);
	        }	        
	        name.setText(str);	 
	       	        
	        return vi;
	}

}
