/**
 *  UOC Hive Campus per UOC OPEN API
 *  <br />
 *  
 *
 *  @author Ral Martnez Daz
 *  @version 1.0
 */
package com.uoc.hive.campus;


import java.util.ArrayList;
import java.util.Iterator;

import com.uoc.hive.campus.model.Board;
import com.uoc.hive.campus.model.BoardList;
import com.uoc.hive.campus.model.ClassRoom;
import com.uoc.hive.campus.model.ClassRoomList;

import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;


public class listClassRoomAdapter extends BaseAdapter {
	
	private ArrayList<ClassRoom> classRooms;
	private Activity activity;
	private static LayoutInflater inflater=null;
	
	// Quantitat de caracters que es mostraran.
	
	private static int titleSize = 60;
		

	/**
	 * 
	 */
	public listClassRoomAdapter(Activity a,ClassRoomList m) {
		this.activity = a;
		this.classRooms = m.getAulesList();
		inflater = (LayoutInflater)activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);		
		
	}

	@Override
	public int getCount() {
		return classRooms.size();
	}

	@Override
	public Object getItem(int position) {
		return position;
	}

	@Override
	public long getItemId(int position) {		
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		 	String str;			 	
			View vi=convertView;
			long unreadMessages = 0;
						 
	        if(convertView==null)
	        	vi = inflater.inflate(R.layout.list_classrooms_row, null);
	 
	        TextView title = (TextView)vi.findViewById(R.id.listClassRoom_title); 	// nom de l'aula        
	        TextView messages = (TextView)vi.findViewById(R.id.listClassRoom_pendent); 	// nom de l'aula
	        
	        ClassRoom classRoom = classRooms.get(position);
	        
	        // Comprovem si eals recursos de conversa de l'aula hi ha missatges pendents de llegir.
	        BoardList classBoards = classRoom.getBoards();	       
	        if ( classBoards != null ){
	        	Iterator<Board> itr = classBoards.getBoardList().iterator();
	        	while(itr.hasNext()) {
	        		Board element =  itr.next();
	        		unreadMessages = unreadMessages + element.getUnreadMessages();	        						    
	        	}
	        }
	        
	        if (unreadMessages > 0){
	        	messages.setText(Long.toString(unreadMessages));
	        } else {
	        	messages.setText(0);
	        }
	        
	       	        
	        
	        // Recuperem el Remitent del missatge
	        str =  classRoom.getTitle();
	        if (str.length() > titleSize) {
	    	    str = Utilities.cutString(titleSize,str);
	        }	        
	        title.setText(str);	 
	       	        
	        return vi;
	}

}
