/**
 *  UOC Hive Campus per UOC OPEN API
 *  <br />
 *  
 *
 *  @author Ral Martnez Daz
 *  @version 1.0
 */
package com.uoc.hive.campus;


import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import com.uoc.hive.campus.model.Event;
import com.uoc.hive.campus.model.EventList;

import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;


public class listEventAdapter extends BaseAdapter {
	
	private ArrayList<Event> events;
	private Activity activity;
	private static LayoutInflater inflater=null;
	
	// Quantitat de caracters que es mostraran.
	
	private static int titleSize = 30;
	
	private SimpleDateFormat sdf = new SimpleDateFormat("EEE, d MMM");	
		

	/**
	 *  
	 */
	public listEventAdapter(Activity a,EventList m) {
		this.activity = a;
		this.events = m.getEventsList();
		inflater = (LayoutInflater)activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		
	}

	@Override
	public int getCount() {
		return events.size();
	}

	@Override
	public Object getItem(int position) {
		return position;
	}

	@Override
	public long getItemId(int position) {		
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
			Date data = new Date();
		 	String str;			 	
			View vi=convertView;
			
						 
	        if(convertView==null)
	        	vi = inflater.inflate(R.layout.list_event_row, null);
	 
	        TextView date = (TextView)vi.findViewById(R.id.event_date); 	// nom del recurs       	      	
	        TextView subject = (TextView)vi.findViewById(R.id.event_subject);	
	        
	       
	        // TextView hour = (TextView)vi.findViewById(R.id.event_time); 
	     	        
	        Event event = events.get(position);
	        
	        data.setTime(event.getStart());	        
	        date.setText(sdf.format(data));	
	        
	        //  data.setTime(event.getStart());	        
	        //  date.setText(sdf.format(data));   
	        
	        // Recuperem el nom de l'event
	        str = event.getSummary();	        
	        if (str.length() > titleSize) {
	    	    str = Utilities.cutString(titleSize,str);
	        }	        
	        subject.setText(str);
	        
	     
	       	        
	        return vi;
	}

}
