/**
 *  UOC Hive Campus per UOC OPEN API
 *  <br />
 *  
 *
 *  @author Ral Martnez Daz
 *  @version 1.0
 */


package com.uoc.hive.campus;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import com.uoc.hive.campus.model.Message;
import com.uoc.hive.campus.model.MessageList;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class mailAdapter extends BaseAdapter {
	
	private ArrayList<Message> messages;
	private Activity activity;
	private static LayoutInflater inflater=null;
	
	// Quantitat de caracters que es mostraran.
	private static int subjectSize = 50;
	private static int fromSize = 35;
		

	/**
	 * 
	 */
	public mailAdapter(Activity a,MessageList m) {
		this.activity = a;
		this.messages = m.getMessageList();
		inflater = (LayoutInflater)activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);		
		
	}

	@Override
	public int getCount() {
		return messages.size();
	}

	@Override
	public Object getItem(int position) {
		return position;
	}

	@Override
	public long getItemId(int position) {		
		return position;
	}

	@SuppressLint("SimpleDateFormat")
	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		 	String str;			 	
			View vi=convertView;	
			Date data;
			SimpleDateFormat sdf = new SimpleDateFormat("hh:mm - EEE, d MMM");			
		 
	        if(convertView==null)
	        	vi = inflater.inflate(R.layout.list_mail_row, null);
	 
	        TextView subject = (TextView)vi.findViewById(R.id.listMail_subject); 	// Tema de missatge        
	        TextView date = (TextView)vi.findViewById(R.id.listMaildate); 			// Data del missatge	        
	        TextView from = (TextView)vi.findViewById(R.id.listMail_from); 			// Remitent
	        ImageView image = (ImageView)vi.findViewById(R.id.listMail_image); 		
	        
	        Message message = messages.get(position);
	       	        
	        
	        // Recuperem el Remitent del missatge
	        str =  message.getFrom();
	        if (str.length() > fromSize) {
	    	    str = Utilities.cutString(fromSize,str);
	        }	        
	        subject.setText(str);	 
	        
	        // Recuperem el tema del missatge
	        str =  message.getSubject();
	        if (str.length() > subjectSize) {
	    	    str = Utilities.cutString(subjectSize,str);
	        }	        
	        from.setText(str);	
	        
	        // Si el missatge no est llegit, mostrem la icona
	        if (message.getStatus() == 0){
	        	image.setVisibility(ImageView.VISIBLE);
	        }
	        
	        // Recuperem la data en format Date
	        data = Utilities.parseDateTime(message.getDate());	        
	       
	        date.setText(sdf.format(data));     	       
	        
	        return vi;
	}

}
