/**
 * 
 */
package com.uoc.hive.campus.model;

/**
 * @author 00
 *
 */

import java.util.ArrayList;

import android.util.Log;

import com.google.gson.Gson;
import com.uoc.hive.campus.RESTClientConnection;



public class EventList {
	
		private ArrayList<Event> events;
		
		final static String URI =  Constants.BASEURI + "calendar/events";

		public EventList() {
		}

		/**
		 * Obt el llistat d'events
		 * @return un llistat d'objectes Event
		 */
		public ArrayList<Event> getEventsList() {
			return events;
		}

		public void setEventsList(ArrayList<Event> eventList) {
			this.events = eventList;
		}
		
		/**
		 * Obt el llistat complet d'events.		
		 * @param ouathtoken Un token d'usuari vlid.
		 * @return un objecte EventList amb el conjunt d'events.
		 */
		public static EventList getEvents(String ouathtoken) {	
			String requestUri = Constants.BASEURI+ "calendar/events";
			String jsonString =  getEventListRequest( requestUri , ouathtoken);
			
			if (jsonString != null ) {	
				Log.i("iEventList", jsonString);
				return JSONtoEventList(jsonString);
			}
			return null;
		}
			
				
		/**
		 * Obt un llistat d'events del Campus Virtual
		 * @return una cadena JSON amb el llistat d'events 
		 */
		public static String getEventListRequest(String URI, String ouathtoken) {				
			return  RESTClientConnection.Get( URI , ouathtoken);		
		}

		/**
		 * Deserialitza un cadena JSON en un objecte EventList.
		 * @param jsonString La cadena JSON.
		 * @return un objecte EventList amb els objectes Event serialitzats.
		 */
		private static EventList JSONtoEventList(String jsonString) {
			return new Gson().fromJson(jsonString, EventList.class);
		}

	
}