/**
 * 
 */
package com.uoc.hive.campus.model;

import android.util.Log;

import com.google.gson.Gson;
import com.uoc.hive.campus.RESTClientConnection;

/**
 * @author 00
 *
 */
public class Folder {
	private String id; 				// Identificador de la carpeta
	private String name; 			// Nom de la carpeta
	private long unreadMessages;    // Nmero de missatges no llegits
	private long totalMessages;		// Nmero de missatges de la carpeta
	
	final static String URI =  Constants.BASEURI;

	/**
	 * 
	 */	
	public Folder() {
		// TODO Auto-generated constructor stub
	}		
	
	
	/**
	 * Retorna el nombre de missatges no llegits-
	 * @return the unreadMessages
	 */
	public long getUnreadMessages() {
		return unreadMessages;
	}	

	/**
	 * Retorna el nombre total de missatges que hi ha  a la carpeta.
	 * @return the totalMessages
	 */
	public long getTotalMessages() {
		return totalMessages;
	}
	
	
	/**
	 * @return the id
	 */
	public String getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}



	public static Folder getFolder (String URI , String oathtoken) {
		String requestURI = Constants.BASEURI  + URI;
		String jsonString = getFolderRequest( requestURI, oathtoken);
		
		if (jsonString != null ) {
			return JSONtoFolder(jsonString);			
		}
		return null;
	}
	
	/**
	 * Obt les dades de la carpeta Rebuts
	 * @return una cadena JSON amb les dades de de carpeta Rebuts
	 */
	public static String getFolderRequest(String URI, String oathtoken) {			
		return RESTClientConnection.Get( URI , oathtoken);
	}
	
	/**
	 * Serialitza un cadena JSON en un objecte Folder.
	 * @param jsonString La cadena JSON.
	 * @return un objecte Folder amb les dades de la carpeta.
	 */
	public static Folder JSONtoFolder(String jsonString) {
		return new Gson().fromJson(jsonString, Folder.class);
	}

	

}
