/**
 * 
 */
package com.uoc.hive.campus.model;

/**
 * @author 00
 *
 */

import java.util.ArrayList;

import android.util.Log;

import com.google.gson.Gson;
import com.uoc.hive.campus.RESTClientConnection;



public class FolderList {
	
		private ArrayList<Folder> folders;

		public FolderList() {
		}

		/**
		 * Obt el llistat de carpetes
		 * @return un llistat d'objectes Folder
		 */
		public ArrayList<Folder> getFolderList() {
			return folders;
		}

		public void setFolderList(ArrayList<Folder> folderList) {
			this.folders = folderList;
		}
		
		/**
		 * Obt un llistat de  carpetes .
		 * @param URI l'adrea del conjunt de carpetes a  recuperar.
		 * @param ouathtoken Un token d'usuari vlid.
		 * @return un objecte FolderList amb el conjunt de carpetes.
		 */
		public static FolderList getFolders(String URI, String ouathtoken) {	
			String requestUri = Constants.BASEURI +URI;
			String jsonString =  getFolderListRequest( requestUri , ouathtoken);
			
			if (jsonString != null ) {				
				return JSONtoFolderList(jsonString);
			}
			return null;
		}
			
				
		/**
		 * Obt un llistat de carpetes del Campus Virtual
		 * @return una cadena JSON amb el llistat de carpetes
		 */
		public static String getFolderListRequest(String URI, String ouathtoken) {				
			return  RESTClientConnection.Get( URI , ouathtoken);		
		}

		/**
		 * Deserialitza un cadena JSON en un objecte FolderList.
		 * @param jsonString La cadena JSON.
		 * @return un objecte FolderList amb els objectes Folder serialitzats.
		 */
		private static FolderList JSONtoFolderList(String jsonString) {
			return new Gson().fromJson(jsonString, FolderList.class);
		}

	
}