package com.uoc.hive.campus.model;

import com.google.gson.Gson;
import com.uoc.hive.campus.RESTClientConnection;

public class Message {
	
	private String id; 			//	Identificador del missatge
	private String subject; 	//	Tema del missatge
	private	String snippet; 	//	Primers caracters del missatge
	private String date; 		//	Data del missatge
	private long color; 		//	Etiqueta de color del missatge
	private long status; 		//	Status del missatge
	private String from; 		//	Remitent del missatge
	private String to; 			//	Destinataris del missatge
	private String cc; 			//	Destinataris del missatge en cpia
	private String body; 		//	Cos del missatge
	
	

	public Message() {
		// TODO Auto-generated constructor stub
	}
		
	

	/**
	 * @return the id
	 */
	public String getId() {
		return id;
	}


	/**
	 * @param id the id to set
	 */
	public void setId(String id) {
		this.id = id;
	}
	/**
	 * @return the subject
	 */
	public String getSubject() {
		return subject;
	}


	/**
	 * @param subject the subject to set
	 */
	public void setSubject(String subject) {
		this.subject = subject;
	}


	
	/**
	 * @return the snippet
	 */
	public String getSnippet() {
		return snippet;
	}


	/**
	 * @param snippet the snippet to set
	 */
	public void setSnippet(String snippet) {
		this.snippet = snippet;
	}


	/**
	 * @return the from
	 */
	public String getFrom() {
		return from;
	}


	/**
	 * @param from the from to set
	 */
	public void setFrom(String from) {
		this.from = from;
	}
	
	/**
	 * @return the date
	 */
	public String getDate() {
		return date;
	}


	/**
	 * @param date the date to set
	 */
	public void setDate(String date) {
		this.date = date;
	}


	/**
	 * @return the color
	 */
	public long getColor() {
		return color;
	}


	/**
	 * @param color the color to set
	 */
	public void setColor(long color) {
		this.color = color;
	}


	/**
	 * @return the status
	 */
	public long getStatus() {
		return status;
	}


	/**
	 * @param status the status to set
	 */
	public void setStatus(long status) {
		this.status = status;
	}


	/**
	 * @return the to
	 */
	public String getTo() {
		return to;
	}


	/**
	 * @param to the to to set
	 */
	public void setTo(String to) {
		this.to = to;
	}


	/**
	 * @return the cc
	 */
	public String getCc() {
		return cc;
	}


	/**
	 * @param cc the cc to set
	 */
	public void setCc(String cc) {
		this.cc = cc;
	}


	/**
	 * @return the body
	 */
	public String getBody() {
		return body;
	}


	/**
	 * @param body the body to set
	 */
	public void setBody(String body) {
		this.body = body;
	}

	
	/**
	 * Recupera un missatge del Campus.
	 * @param URI - l'adrea per la consulta REST 
	 * @return objecte Message amb les dades del missatge.
	 */
	public static Message getMessage (String URI, String oathtoken) {
		String requestURI = Constants.BASEURI + URI;
		String jsonString = getJSONMessageRequest (requestURI, oathtoken);
		
		if (jsonString != null ) {	
			return JSONtoMessage(jsonString);
		}
		return null;
		
	}

	/**
	 * Recupera les dades d'un missatge del Campus Virtual.
	 * @return una cadena JSON amb les dades del missatge.
	 */
	public static String getJSONMessageRequest(String URI, String token) {		
		return RESTClientConnection.Get( URI ,token);
	}
	
	/**
	 * Des-serialitza un cadena JSON en un objecte Message.
	 * @param jsonString La cadena JSON.
	 * @return un objecte Message.
	 */
	public static Message JSONtoMessage(String jsonString) {		
		return new Gson().fromJson(jsonString, Message.class);		
	}


	

	

}
