package com.uoc.hive.campus.model;

import com.google.gson.Gson;
import com.uoc.hive.campus.RESTClientConnection;

public class MessageBody {
	
	private String id; 			//	Identificador del missatge	
	private String body; 		//	Cos del missatge
	
	

	public MessageBody() {
		// TODO Auto-generated constructor stub
	}
		
	

	/**
	 * @return the id
	 */
	public String getId() {
		return id;
	}


	/**
	 * @param id the id to set
	 */
	public void setId(String id) {
		this.id = id;
	}
	
	/**
	 * @return the body
	 */
	public String getBody() {
		return body;
	}


	/**
	 * @param body the body to set
	 */
	public void setBody(String body) {
		this.body = body;
	}

	
	/**
	 * Recupera el cos d'un missatge del Campus.
	 * @param URI - l'adrea per la consulta REST 
	 * @return objecte MessageBody amb el cos del missatge.
	 */
	public static MessageBody getMessageBody (String URI, String oathtoken) {
		String requestURI = Constants.BASEURI + URI;
		String jsonString = getJSONMessageBodyRequest (requestURI, oathtoken);
		
		if (jsonString != null ) {	
			return JSONtoMessageBody(jsonString);
		}
		return null;
		
	}

	/**
	 * Recupera les dades d'un missatge del Campus Virtual.
	 * @return una cadena JSON amb les dades del missatge.
	 */
	public static String getJSONMessageBodyRequest(String URI, String token) {		
		return RESTClientConnection.Get( URI ,token);
	}
	
	/**
	 * Des-serialitza un cadena JSON en un objecte Message.
	 * @param jsonString La cadena JSON.
	 * @return un objecte Message.
	 */
	public static MessageBody JSONtoMessageBody(String jsonString) {		
		return new Gson().fromJson(jsonString, MessageBody.class);		
	}


	

	

}
