/**
 * 
 */
package com.uoc.hive.campus.model;

/**
 * @author 00
 *
 */

import java.util.ArrayList;

import android.util.Log;

import com.google.gson.Gson;
import com.uoc.hive.campus.RESTClientConnection;



public class MessageList {
	
		private ArrayList<Message> messages;

		public MessageList() {
		}

		/**
		 * Obt el llistat de missatges
		 * @return un llistat d'objecte Message
		 */
		public ArrayList<Message> getMessageList() {
			return messages;
		}

		public void setMessageList(ArrayList<Message> messageList) {
			this.messages = messageList;
		}
		
			
		/**
		 * Obt un llistat de missatges.
		 * @param URI l'adrea del conjunt de missatges a recuperar.
		 * @param ouathtoken Un token d'usuari vlid.
		 * @return un objecte MessageList amb el conjunt de missatges.
		 */
		public static MessageList getMessages(String URI, String ouathtoken) {	
			String requestUri = Constants.BASEURI + URI;
			String jsonString =  getMessageListRequest( requestUri , ouathtoken);
			
			if ( jsonString != null){
				Log.i("iMessageList", jsonString);
				return JSONtoMessageList(jsonString);
			}
			return null;		
		}
				
		/**
		 * Obt un llistat de missatges del Campus Virtual
		 * @return una cadena JSON amb el llistat de missatges
		 */
		public static String getMessageListRequest(String URI, String ouathtoken) {				
			return RESTClientConnection.Get( URI , ouathtoken);	
		}

		/**
		 * Deserialitza un cadena JSON en un objecte MessageList.
		 * @param jsonString La cadena JSON.
		 * @return un objecte MessageList amb els objectes Message serialitzats.
		 */
		private static MessageList JSONtoMessageList(String jsonString) {
			return new Gson().fromJson(jsonString, MessageList.class);
		}

	
}