package com.uoc.hive.campus.model;


import com.google.gson.Gson;
import com.uoc.hive.campus.RESTClientConnection;

public class User {
	private String id; 				// Identificador de l'usuari
	private String fullName;		// Nom complert de l'usuari
	private String username;		// Nom d'usuari de l'usuari dins el Campus
	private String name;			// Nom de l'usuari
	private String language;		// Idioma de l'usuari en format ISO
	private String number;			// Nmero d'estudiant
	private String photoUrl; 		// URL de la foto de l'usuari
	
	private static String userJson;

	final static String URI =  Constants.BASEURI + "user";

	
	public User(){
		//Default constructor
	}
	
	
	public String getFullName() {
		return fullName;
	}

	public void setFullName(String fullName) {
		this.fullName = fullName;
	}

	public String getId() {
		return id;
	}

	public String getNumber() {
		return number;
	}
	
	public String getLanguage() {
		return language;
	}

	public void setLenguage(String language) {
		this.language = language;
	}

	public String getName() {
		return name;
	}

	public String getPhotoUrl() {
		return photoUrl;
	}

	public void setPhotoUrl(String photoUrl) {
		this.photoUrl = photoUrl;
	}

	public String getUsername() {
		return username;
	}
	
	public String getUserJson() {
		return userJson;
	}

		
	public static User getUser (String oathtoken) {
		String jsonString = getJSONUserRequest (oathtoken);
		return JSONToUser(jsonString);
	}
	
	/**
	 * Recupera les dades de l'usuari del Campus Virtual.
	 * @return una cadena JSON amb les dades de l'usuari.
	 */
	public static String getJSONUserRequest(String token) {
		return RESTClientConnection.Get( URI , token);
	}
	
	/**
	 * Des-serialitza un cadena JSON en un objecte User.
	 * @param jsonString La cadena JSON.
	 * @return un objecte User.
	 */
	public static User JSONToUser(String jsonString) {		
		User obj = new Gson().fromJson(jsonString, User.class);
		return obj;
	}
}
