/**
 * 
 */
package com.uoc.hive.campus.model;

/**
 * @author 00
 *
 */

import java.util.ArrayList;

import android.util.Log;

import com.google.gson.Gson;
import com.uoc.hive.campus.RESTClientConnection;

public class UserList {
	
		private ArrayList<User> users;

		public UserList() {
		}

		/**
		 * Obt el llistat d'usuaris
		 * @return un llistat d'objecte User
		 */
		public ArrayList<User> getUserList() {
			return users;
		}

		public void setUserList(ArrayList<User> userList) {
			this.users = userList;
		}
		
		/**
		 * Obt el llistat de tutors de l'usuari.
		 * @param ouathtoken Un token d'usuari vlid.
		 * @return un objecte UserList amb els tutors de l'usuari.
		 */
		public static UserList getUserTutorsRequest(String ouathtoken) {	
			String requestUri = Constants.BASEURI + "user" + "/tutors";
			String jsonString =  RESTClientConnection.Get( requestUri , ouathtoken);
			
			return JSONtoUserList(jsonString);
		}
		
		/**
		 * Obt un llistat d'usuaris del Campus Virtual
		 * @return una cadena JSON amb el llistat d'usuaris
		 */
		public static String getUserListRequest(String ouathtoken) {	
			String requestUri = Constants.BASEURI + "user" + "/tutors";
			String jsonString =  RESTClientConnection.Get( requestUri , ouathtoken);			
			return jsonString;
		}

		/**
		 * Deserialitza un cadena JSON en un objecte UserList.
		 * @param jsonString La cadena JSON.
		 * @return un objecte UserList amb els objectes User serialitzats.
		 */
		private static UserList JSONtoUserList(String jsonString) {
			return new Gson().fromJson(jsonString, UserList.class);
		}

	
}